;; locallabels.asm  Testen von Labels

.nolist
.include "m8def.inc"
.list
	rjmp main

	rjmp _L0
	nop
_L0:	nop

small_loop:
	push r16
	tst r16
	breq _L2
_L1:	nop
	dec r16
	brne _L1
_L2:	pop r16
	ret
;	rjmp _L0 	;should give error

.def tmp_reg=r18
big_loop:
	push r16
	push r17
	push tmp_reg
	clr tmp_reg
	cp  r16, tmp_reg
	cpc r17, tmp_reg
	breq _L2
_L1:	nop
	subi r16, 1
	sbc  r17, tmp_reg
	brne _L1
_L2:	pop tmp_reg
	pop r17
	pop r16
	ret
.undef tmp_reg
	
main:   ldi r16, low(RAMEND)
        out SPL, r16
        ldi r16, high(RAMEND)
        out SPH, r16

mainloop:
	ldi r16, 100
	rcall small_loop
	ldi r16, low(1000)
	ldi r17, high(1000)
	rcall big_loop
;	call big_loop   ;not supported on ATmega8
	rcall test3
;	rcall _L2	;should give error
;_L3:	rcall _L4	;should give error
	rcall _L4	;should work if no local label before test3
	rjmp mainloop

.def tmp_reg=r17
test3:
	push tmp_reg
	rjmp _L3
	nop
_L3:	pop tmp_reg
_L4:	ret
